import title2bib.crossref as tc
import doi2bib.crossref as dc
from habanero import Crossref

cr = Crossref()

# old reader
def read_bibitems_single_line(inName):
    f = open(inName)
    l = f.readlines()
    f.close()
    return l

# new reader which grabs everything between bibitem entries with newlines
def read_bibitems(inName):
    f = open(inName)
    line_list = f.readlines()
    f.close()
    nlines = len(line_list)
    cntr = 0
    s = ''
    bibitem_list = []
    while cntr < nlines:
        if line_list[cntr].find('bibitem') >= 0:
            bibitem_list.append(s.strip())
            s = ''
        else:
            s += ' '
        s += line_list[cntr].strip()
        cntr += 1
    bibitem_list.append(s.strip())
    return bibitem_list[1:]

# COULD REPLACE SPLIT WITH FIND

def parsekey(bibitem):
    a = bibitem.split('{')[1]
    b = a.split('}')[0]
    return b

def parsetitle(bibitem):
    a = bibitem.split("``")[1]
    b = a.split("\'\'")[0]
    return b

def parseauthors(bibitem):
    a = bibitem.split('}')[1]
    b = a.split("``")[0]
    return b

def mytitle2doi(title):
    r = cr.works(query=title)
    r0 = r['message']['items'][0]
    doi = r0['DOI']
    title = r0['title'][0]
    author_list = r0['author']
    authors = ''
    try:
        for author in author_list:
            family = author['family']
            authors += " "
            authors += family
    except:
        print('ERROR WITH AUTHORS BUT TRYING TO CONTINUE')
    return (doi,title, authors)

def mytitle2bib(title):
    b = tc.get_bib_from_title(title)
    return b

def mydoi2bib(doi):
    b = dc.get_bib_from_doi(doi)
    return b

def printall(bibitems):
    for bibitem in bibitems:
        key = parsekey(bibitem)
        print(key)
        title = parsetitle(bibitem)
        authors = parseauthors(bibitem)
        doi,title2,authors2 = mytitle2doi(title)
        print(title)
        print(title2)
        print(authors)
        print(authors2)
        print(doi)
        print('')
    return

def bibtex_insert_key(bibtex, key):
    tmp0 = bibtex.find('{')
    tmp1 = bibtex.find(',')
    return bibtex[0:tmp0+1] + key + bibtex[tmp1:]

def process_bibitem_file_titles(bibitems_in, bibtex_out, bibitems_out, start=0):
    bibitems = read_bibitems(bibitems_in)
    ftex = open(bibtex_out,'w')
    fitems = open(bibitems_out,'w')
    for i in range(start,len(bibitems)):
        bibitem = bibitems[i]
        key = parsekey(bibitem)
        print(str(i) + " " + key)
        title = parsetitle(bibitem)
        authors = parseauthors(bibitem)
        try:
            doi,title2,authors2 = mytitle2doi(title)
        except:
            print('ERROR: TROUBLE FINDING DOI FROM TITLE\n')
            fitems.write(bibitem)
            fitems.write('\n')
            fitems.flush()
            continue
        print('title1:   ' + title)
        print('title2:   ' + title2)
        print('authors1: ' + authors)
        print('authors2: ' + authors2)
        a = input('correct (y|n)? ')
        if a.lower() == 'y':
            b = mydoi2bib(doi)
            if b[0]:
                tmp = b[1]
                tmp0 = tmp.find('{')
                tmp1 = tmp.find(',')
                ftex.write(tmp[0:tmp0+1] + key + tmp[tmp1:])
                ftex.write('\n')
                ftex.flush()
            else:
                print('ERROR: TROUBLE FINDING BIB FROM DOI\n')
                fitems.write(bibitem)
                fitems.write('\n')
                fitems.flush()
        else:
            fitems.write(bibitem)
            fitems.write('\n')
            fitems.flush()
        print('')
    ftex.close()
    fitems.close()
    return
